pipeline {
    agent {
        label 'docker'
    }
    environment {
        GITLAB_USERNAME = "${env.GITLAB_USER_USERNAME}"
        GITLAB_PASSWORD = "${env.GITLAB_USER_PASSWORD}"
    }
    stages {
        stage('Preparation') {
           steps {
               script {
                    def runningPipelinesCount = 1

                    while (runningPipelinesCount > 0) {
                        def response = bat(script: 'curl -o result.txt --request GET --url "https://${GITLAB_USERNAME}:${GITLAB_PASSWORD}@gitlab.com/api/v4/projects/51932364/pipelines?status=running"',  returnStdout: true).trim()
                        def json = readFile('result.txt')
                        def lista = new groovy.json.JsonSlurperClassic().parseText(json)
                        runningPipelinesCount = lista.size()

                        if (runningPipelinesCount == 0) {
                            echo "Nothing pipelines in execute. Next..."
                        } else {
                            echo "Have ${runningPipelinesCount} pipelines in execute. waiting 5 seconds before the returning verify..."
                            sleep(time: 5, unit: 'SECONDS')
                        }
                    }

                    bat "git config --global submodule.recurse false"

                    git branch: 'main', credentialsId: 'integration_gitlab_jenkins', url: 'https://gitlab.com/softgram/frontend/root.git'

                    bat "git submodule init"
                    bat "git submodule update --init --recursive -- apps/web"

                    dir("apps") {
                        bat(script: 'powershell.exe -Command "Get-ChildItem | Where-Object { $_.Name -ne \\\"web\\\" } | ForEach-Object { Remove-Item -Path $_.FullName -Recurse -Force }"')
                    }
                    
                    try {
                        bat "mkdir settings"
                    } catch(Exception e) {
                        echo "Not create folder settings because if exists"

                        try {
                            bat "rmdir /s /q .vercel"
                        } catch(Exception exception) { 
                            echo "Not delete folder .vercel"
                        }
                    }
                    
                    dir("settings") {
                          git branch: 'main', credentialsId: 'integration_gitlab_jenkins', url: 'https://gitlab.com/softgram/backend/docker-compose.git'
                    }
               }
           }
       }
        stage('Deployment') {
            steps {
                script {
                    bat "move settings/vercel/web/.vercel ."

                    bat "npx vercel --prod"
                }
            }
        }
    }
     post {
        success {
            echo 'Application Success'
        }
    }
}